VERSION 5.00
Object = "{0D452EE1-E08F-101A-852E-02608C4D0BB4}#2.0#0"; "FM20.DLL"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmSpeedometer 
   Caption         =   "Speedometer"
   ClientHeight    =   7350
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8175
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   7350
   ScaleWidth      =   8175
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdTryRichTextBox 
      Caption         =   "Try Me"
      Enabled         =   0   'False
      Height          =   495
      Left            =   4320
      TabIndex        =   6
      Top             =   5760
      Width           =   1815
   End
   Begin VB.CommandButton cmdTryVB6 
      Caption         =   "Try Me If You Dare..."
      Enabled         =   0   'False
      Height          =   495
      Left            =   4320
      TabIndex        =   5
      Top             =   3360
      Width           =   1815
   End
   Begin VB.CommandButton cmdTryForms 
      Caption         =   "Try Me"
      Enabled         =   0   'False
      Height          =   495
      Left            =   4320
      TabIndex        =   4
      Top             =   960
      Width           =   1815
   End
   Begin VB.TextBox txtKB 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   7335
      TabIndex        =   0
      Text            =   "16"
      Top             =   585
      Width           =   360
   End
   Begin VB.TextBox VB6TextBox 
      Height          =   2295
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   3
      Text            =   "TryThis.frx":0000
      Top             =   2520
      Width           =   6735
   End
   Begin RichTextLib.RichTextBox RichTextBox1 
      Height          =   2295
      Left            =   120
      TabIndex        =   1
      Top             =   4920
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   4048
      _Version        =   393217
      TextRTF         =   $"TryThis.frx":001D
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "KB"
      Height          =   195
      Left            =   7800
      TabIndex        =   8
      Top             =   630
      Width           =   210
   End
   Begin MSForms.SpinButton spinKB 
      Height          =   495
      Left            =   7080
      TabIndex        =   7
      Top             =   480
      Width           =   255
      Size            =   "450;873"
   End
   Begin MSForms.TextBox FormsTextBox 
      Height          =   2295
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   6735
      VariousPropertyBits=   -1467987941
      Size            =   "11880;4048"
      Value           =   "FM20.DLL -- Microsoft Forms 2.0 Object Library"
      FontHeight      =   165
      FontCharSet     =   0
      FontPitchAndFamily=   2
   End
End
Attribute VB_Name = "frmSpeedometer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim str1KB As String, iLim As Long
Dim tSTART As Single, tEND As Single


' Puts strings into a Forms textbox and times it.
Private Sub cmdTryForms_Click()
Dim i As Long
Dim buf As String

    On Error GoTo theErr
    EnableButtons False
    FormsTextBox.Text = ""
    tSTART = Timer
    '----------------------------------------
        For i = 1 To iLim
            buf = buf & str1KB ' 1K at a time
            FormsTextBox.Text = buf
        Next i
    '----------------------------------------
    tEND = Timer
    MsgBox "Elapsed: " & Format(tEND - tSTART, "#,##0.00") & " seconds"
    EnableButtons True
    Exit Sub

theErr:
    MsgBox "Error: " & Err.Description & vbCrLf & "Len(buf) = " & Len(buf)
End Sub

' Puts strings into a Rich textbox and times it.
Private Sub cmdTryRichTextBox_Click()
Dim i As Long
Dim buf As String

    On Error GoTo theErr
    EnableButtons False
    RichTextBox1.Text = ""
    tSTART = Timer
    '----------------------------------------
        For i = 1 To iLim
            buf = buf & str1KB ' 1K at a time
            RichTextBox1.Text = buf
        Next i
    '----------------------------------------
    tEND = Timer
    MsgBox "Elapsed: " & Format(tEND - tSTART, "#,##0.00") & " seconds"
    EnableButtons True
    Exit Sub

theErr:
    MsgBox "Error: " & Err.Description & vbCrLf & "Len(buf) = " & Len(buf)
End Sub

' Puts strings into a VB6 textbox and times it.
Private Sub cmdTryVB6_Click()
Dim i As Long
Dim buf As String

    On Error GoTo theErr
    EnableButtons False
    VB6TextBox.Text = ""
    tSTART = Timer
    '----------------------------------------
        For i = 1 To iLim
            buf = buf & str1KB ' 1K at a time
            VB6TextBox.Text = buf
        Next i
    '----------------------------------------
    tEND = Timer
    MsgBox "Elapsed: " & Format(tEND - tSTART, "#,##0.00") & " seconds"
    EnableButtons True
    Exit Sub

theErr:
    MsgBox "Error: " & Err.Description & vbCrLf & "Len(buf) = " & Len(buf)
End Sub

Private Sub Form_Load()
Dim i As Long

    For i = 1 To 64  ' 1KB
        str1KB = str1KB & "0123456789ABCDEF"
    Next i
    
    spinKB.Value = Val(txtKB.Text)
    iLim = spinKB.Value 'iteration limit

    EnableButtons True
End Sub


Private Sub EnableButtons(Truth As Boolean)
    cmdTryForms.Enabled = Truth
    cmdTryVB6.Enabled = Truth
    cmdTryRichTextBox.Enabled = Truth
    If txtKB.Visible Then txtKB.SetFocus
End Sub

Private Sub spinKB_Change()
    txtKB.Text = spinKB.Value
    iLim = spinKB.Value 'iteration limit
    If txtKB.Visible Then txtKB.SetFocus
End Sub

Private Sub txtKB_Change()
Dim n As Integer
    n = Val(txtKB.Text)
    If n > spinKB.Max Then n = spinKB.Max
    If n < spinKB.Min Then n = spinKB.Min
    spinKB.Value = n
    iLim = n 'iteration limit
    txtKB.Text = n
End Sub

Private Sub txtKB_GotFocus()
    txtKB.SelStart = 0
    txtKB.SelLength = Len(txtKB.Text)
End Sub
